#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <time.h>
#include "netfd.h"

#define	DEF_ADDR	"192.168.1.23"
#define	DEF_PORT	"27182"
#define	DEF_TIMEOUT	(5000)

static void	send_text(netfd_t *, const char *);

int
main(argc, argv)
	int	argc;
	char *	argv[];
{
  const char	mesg1[] = "Hello TekeP World!\n";
  const char	mesg2[] = "Good Morning!\n";

  if (netfd_init(0) == 0) {
    netfd_t *	nfd;

    nfd = netfd_tcp_client(DEF_ADDR, DEF_PORT, DEF_TIMEOUT);
    if (nfd != NULL) {
      send_text(nfd, mesg1);
      send_text(nfd, mesg2);
      netfd_close(nfd);
    }
  }

  return 0;
}

static void
send_text(nfd, mesg)
	netfd_t *	nfd;
	const char *	mesg;
{
  char	buf[BUFSIZ];

  netfd_write(nfd, mesg, strlen(mesg), NETFD_NO_TIMEOUT);
  memset(buf, 0, sizeof(buf));
  netfd_readline(nfd, buf, sizeof(buf), NETFD_NO_TIMEOUT);
  fputs(buf, stdout);
}
