#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <time.h>
#include <errno.h>
#include "netfd.h"

#define	DEF_ADDR	"192.168.1.23"
#define	DEF_PORT	"27182"
#define	DEF_BACKLOG	(2)

static void	echo(netfd_t *);

int
main(argc, argv)
	int	argc;
	char *	argv[];
{
  if (netfd_init(0) == 0) {
    netfd_t *	nsd;

    nsd = netfd_tcp_server(DEF_ADDR, DEF_PORT, DEF_BACKLOG);
    if (nsd != NULL) {
      for (;;) {
	struct sockaddr 	cliaddr;
	socklen_t		clilen;
	netfd_t *		nfd;

	nfd = netfd_accept(nsd, &cliaddr, &clilen, NETFD_NO_TIMEOUT);
	if (nfd != NULL) {
	  echo(nfd);
	  netfd_close(nfd);
	}
      }
      netfd_close(nsd);
    }
  }

  return 0;
}

static void
echo(nfd)
	netfd_t *	nfd;
{
  ssize_t	n;

  do {
    char	buf[BUFSIZ];

    memset(buf, 0, sizeof(buf));
    n = netfd_readline(nfd, buf, sizeof(buf), NETFD_NO_TIMEOUT);
    if (n > 0) {
      fprintf(stderr, "DEBUG[echo] %s", buf);
      netfd_write(nfd, buf, strlen(buf), NETFD_NO_TIMEOUT);
    }
    if (strncmp(buf, "quit", 4) == 0) {
      break;
    }
  } while (n > 0);
}
